
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="fr">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>ListeTrieePixel &#8212; Documentation Segmentation Image 4.0</title>
    <link rel="stylesheet" href="../_static/nature.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/translations.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Recherche" href="../search.html" /> 
  </head><body>
<div style="background-color: white; text-align: left; padding: 10px 10px 15px 15px">
  <a href="../index.html">
  <img src="../_static/logo.png" border="0" alt="Segmentation Image"/>
  </a>
</div>

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="Index général"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Index des modules Python"
             >modules</a> |</li>
<li><a href="../index.html">Segmentation Image home</a>| </li>
<li><a href="../contents.html">Documentation </a> &raquo;</li>

          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">Code du module</a> &#187;</li> 
      </ul>
    </div>

      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Recherche rapide</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Code source de ListeTrieePixel</h1><div class="highlight"><pre>
<span></span><span class="c1">#####################################</span>
<span class="c1"># Cecile Prouteau</span>
<span class="c1"># CTES Projet Math-Info</span>
<span class="c1"># Projet segmentation d&#39;image</span>
<span class="c1"># 15/03/2019</span>
<span class="c1"># Classe ListeTrieePixel Version 3.0</span>
<span class="c1">#####################################</span>
<span class="kn">import</span> <span class="nn">math</span>

<span class="kn">from</span> <span class="nn">Pixel</span> <span class="k">import</span> <span class="n">Pixel</span>

<span class="c1">### DEBUT de la classe ListeTrieePixel</span>

<div class="viewcode-block" id="ListeTrieePixel"><a class="viewcode-back" href="../tec_doc.html#ListeTrieePixel.ListeTrieePixel">[docs]</a><span class="k">class</span> <span class="nc">ListeTrieePixel</span><span class="p">:</span>
    
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    </span>
<span class="sd">    **AUTRES CLASSES IMPORTEES**</span>
<span class="sd">    </span>
<span class="sd">    * math</span>
<span class="sd">    </span>
<span class="sd">    **LES METHODES**</span>
<span class="sd">     </span>
<span class="sd">    </span>
<span class="sd">    &quot;&quot;&quot;</span>
    
<div class="viewcode-block" id="ListeTrieePixel.__init__"><a class="viewcode-back" href="../tec_doc.html#ListeTrieePixel.ListeTrieePixel.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Constructeur d&#39;un objet ListeTrieePixel (Liste initialisée à vide)</span>

<span class="sd">        </span>
<span class="sd">        :param self: Objet ListeTrieePixel</span>
<span class="sd">        :type self: ListeTrieePixel</span>
<span class="sd">        </span>
<span class="sd">        :return: Objet ListeTrieePixel des pixels dans l&#39;ordre croissant de leurs valeurs</span>
<span class="sd">        :rtype: ListeTrieePixel</span>
<span class="sd">        </span>
<span class="sd">        Liste des champs de la classe</span>
<span class="sd">        </span>
<span class="sd">        * self.liste liste triée de Pixels dans l&#39;ordre croissant de leurs valeurs</span>


<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">liste</span><span class="o">=</span><span class="p">[]</span></div>
    
    <span class="c1">## Fonctions sur les listes triées de pixels</span>

<div class="viewcode-block" id="ListeTrieePixel.insere_pixel"><a class="viewcode-back" href="../tec_doc.html#ListeTrieePixel.ListeTrieePixel.insere_pixel">[docs]</a>    <span class="k">def</span> <span class="nf">insere_pixel</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">pix</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        </span>
<span class="sd">        Insère un pixel à sa place dans l&#39;objet ListeTrieePixel</span>

<span class="sd">        </span>
<span class="sd">        :param self: Objet ListeTrieePixel</span>
<span class="sd">        :type self: ListeTrieePixel</span>
<span class="sd">        </span>
<span class="sd">        :param pix: pixel à insérer à sa place dans la liste triée en ordre croissant</span>
<span class="sd">        :type pix: Objet Pixel</span>
<span class="sd">        </span>
<span class="sd">        :return: Objet ListeTrieePixel</span>
<span class="sd">        :rtype: ListeTrieePixel</span>
<span class="sd">        </span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">liste</span><span class="p">)</span><span class="o">==</span><span class="mi">0</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">liste</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">pix</span><span class="p">)</span>
        <span class="k">else</span> <span class="p">:</span>
            <span class="n">i</span><span class="o">=</span><span class="mi">0</span>
            <span class="k">while</span> <span class="n">i</span><span class="o">&lt;</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">liste</span><span class="p">)</span> <span class="ow">and</span> <span class="n">pix</span><span class="o">.</span><span class="n">est_superieur</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">liste</span><span class="p">[</span><span class="n">i</span><span class="p">]):</span>
                <span class="n">i</span><span class="o">+=</span><span class="mi">1</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">liste</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="n">i</span><span class="p">,</span><span class="n">pix</span><span class="p">)</span></div>

<div class="viewcode-block" id="ListeTrieePixel.pop_pixel"><a class="viewcode-back" href="../tec_doc.html#ListeTrieePixel.ListeTrieePixel.pop_pixel">[docs]</a>    <span class="k">def</span> <span class="nf">pop_pixel</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">i</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        </span>
<span class="sd">        Extrait le pixel d&#39;indice i dans l&#39;objet ListeTrieePixel, le retourne et le retire de la liste.</span>

<span class="sd">        </span>
<span class="sd">        :param self: Objet ListeTrieePixel</span>
<span class="sd">        :type self: ListeTrieePixel</span>
<span class="sd">        </span>
<span class="sd">        :param i: indice du pixel à retirer de la liste et à retourner.</span>
<span class="sd">        :type i: int</span>
<span class="sd">        </span>
<span class="sd">        :return:  Pixel d&#39;indice i dans la liste self.liste</span>
<span class="sd">        :rtype: Objet Pixel</span>
<span class="sd">        </span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">liste</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="n">i</span><span class="p">)</span></div>
    
<div class="viewcode-block" id="ListeTrieePixel.plus_petit_pixel"><a class="viewcode-back" href="../tec_doc.html#ListeTrieePixel.ListeTrieePixel.plus_petit_pixel">[docs]</a>    <span class="k">def</span> <span class="nf">plus_petit_pixel</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        </span>
<span class="sd">        Retourne le plus petit pixel de la ListeTrieePixel, c&#39;est à dire le premier élément</span>

<span class="sd">        </span>
<span class="sd">        :param self: Objet ListeTrieePixel non vide</span>
<span class="sd">        :type self: ListeTrieePixel</span>
<span class="sd">        </span>
<span class="sd">        :return: Objet ListeTrieePixel</span>
<span class="sd">        :rtype: ListeTrieePixel</span>
<span class="sd">        </span>

<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="c1">#On recupere le premier pixel de la liste </span>

        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">liste</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span></div>

    
<div class="viewcode-block" id="ListeTrieePixel.taille_liste"><a class="viewcode-back" href="../tec_doc.html#ListeTrieePixel.ListeTrieePixel.taille_liste">[docs]</a>    <span class="k">def</span> <span class="nf">taille_liste</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        </span>
<span class="sd">        Retourne le nombre d&#39;éléments de la liste</span>


<span class="sd">        :param self: Objet ListeTrieePixel</span>
<span class="sd">        :type self: ListeTrieePixel</span>
<span class="sd">        </span>
<span class="sd">        :return: le nombre d&#39;éléments de la liste self.liste</span>
<span class="sd">        :rtype: int</span>
<span class="sd">        </span>

<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="k">return</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">liste</span><span class="p">)</span></div>
    
<div class="viewcode-block" id="ListeTrieePixel.est_vide"><a class="viewcode-back" href="../tec_doc.html#ListeTrieePixel.ListeTrieePixel.est_vide">[docs]</a>    <span class="k">def</span> <span class="nf">est_vide</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        </span>
<span class="sd">        Retourne True si la liste self.liste est vide et False sinon</span>


<span class="sd">        :param self: Objet ListeTrieePixel</span>
<span class="sd">        :type self: ListeTrieePixel</span>
<span class="sd">        </span>
<span class="sd">        :return: True si la liste self.liste est vide et False sinon</span>
<span class="sd">        :rtype: bool</span>
<span class="sd">        </span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">liste</span><span class="o">==</span><span class="p">[]</span></div>

<div class="viewcode-block" id="ListeTrieePixel.affiche_liste_triee_pixel"><a class="viewcode-back" href="../tec_doc.html#ListeTrieePixel.ListeTrieePixel.affiche_liste_triee_pixel">[docs]</a>    <span class="k">def</span> <span class="nf">affiche_liste_triee_pixel</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        </span>
<span class="sd">        Affiche la ListeTrieePixel avec toutes les informations de chaque pixel, un par ligne</span>

<span class="sd">        </span>
<span class="sd">        :param self: Objet ListeTrieePixel</span>
<span class="sd">        :type self: ListeTrieePixel</span>
<span class="sd">        </span>
<span class="sd">        :return: None</span>
<span class="sd">        :rtype: None</span>
<span class="sd">        </span>

<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="k">for</span> <span class="n">pix</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">liste</span><span class="p">:</span>
            <span class="n">pix</span><span class="o">.</span><span class="n">affiche_pixel</span><span class="p">()</span></div></div>
</pre></div>

          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="Index général"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Index des modules Python"
             >modules</a> |</li>
<li><a href="../index.html">Segmentation Image home</a>| </li>
<li><a href="../contents.html">Documentation </a> &raquo;</li>

          <li class="nav-item nav-item-1"><a href="index.html" >Code du module</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2019, Cecile Prouteau.
      Créé avec <a href="http://sphinx-doc.org/">Sphinx</a> 1.7.9.
    </div>
  </body>
</html>